// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Effective NetworkSecurityGroup
    /// </summary>
    public partial class EffectiveNetworkSecurityGroup
    {
        /// <summary>
        /// Initializes a new instance of the EffectiveNetworkSecurityGroup
        /// class.
        /// </summary>
        public EffectiveNetworkSecurityGroup() { }

        /// <summary>
        /// Initializes a new instance of the EffectiveNetworkSecurityGroup
        /// class.
        /// </summary>
        /// <param name="networkSecurityGroup">Gets the id of network security
        /// group that is applied</param>
        /// <param name="effectiveSecurityRules">Gets collection of effective
        /// security rules</param>
        public EffectiveNetworkSecurityGroup(Microsoft.Azure.Management.Resource.Fluent.SubResource networkSecurityGroup = default(Microsoft.Azure.Management.Resource.Fluent.SubResource), EffectiveNetworkSecurityGroupAssociation association = default(EffectiveNetworkSecurityGroupAssociation), System.Collections.Generic.IList<EffectiveNetworkSecurityRule> effectiveSecurityRules = default(System.Collections.Generic.IList<EffectiveNetworkSecurityRule>))
        {
            NetworkSecurityGroup = networkSecurityGroup;
            Association = association;
            EffectiveSecurityRules = effectiveSecurityRules;
        }

        /// <summary>
        /// Gets the id of network security group that is applied
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "networkSecurityGroup")]
        public Microsoft.Azure.Management.Resource.Fluent.SubResource NetworkSecurityGroup { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "association")]
        public EffectiveNetworkSecurityGroupAssociation Association { get; set; }

        /// <summary>
        /// Gets collection of effective security rules
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "effectiveSecurityRules")]
        public System.Collections.Generic.IList<EffectiveNetworkSecurityRule> EffectiveSecurityRules { get; set; }

    }
}
