// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Effective Route
    /// </summary>
    public partial class EffectiveRoute
    {
        /// <summary>
        /// Initializes a new instance of the EffectiveRoute class.
        /// </summary>
        public EffectiveRoute() { }

        /// <summary>
        /// Initializes a new instance of the EffectiveRoute class.
        /// </summary>
        /// <param name="name">Gets the name of the user defined route. This
        /// is optional.</param>
        /// <param name="source">Gets who created the route. Possible values
        /// include: 'Unknown', 'User', 'VirtualNetworkGateway',
        /// 'Default'</param>
        /// <param name="state">Gets value of effective route. Possible values
        /// include: 'Active', 'Invalid'</param>
        /// <param name="addressPrefix">Gets address prefixes of the effective
        /// routes in CIDR notation.</param>
        /// <param name="nextHopIpAddress">Gets the IP address of the next hop
        /// of the effective route</param>
        /// <param name="nextHopType">Gets or sets the type of Azure hop the
        /// packet should be sent to. Possible values include:
        /// 'VirtualNetworkGateway', 'VnetLocal', 'Internet',
        /// 'VirtualAppliance', 'None'</param>
        public EffectiveRoute(string name = default(string), string source = default(string), string state = default(string), System.Collections.Generic.IList<string> addressPrefix = default(System.Collections.Generic.IList<string>), System.Collections.Generic.IList<string> nextHopIpAddress = default(System.Collections.Generic.IList<string>), string nextHopType = default(string))
        {
            Name = name;
            Source = source;
            State = state;
            AddressPrefix = addressPrefix;
            NextHopIpAddress = nextHopIpAddress;
            NextHopType = nextHopType;
        }

        /// <summary>
        /// Gets the name of the user defined route. This is optional.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets who created the route. Possible values include: 'Unknown',
        /// 'User', 'VirtualNetworkGateway', 'Default'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "source")]
        public string Source { get; set; }

        /// <summary>
        /// Gets value of effective route. Possible values include: 'Active',
        /// 'Invalid'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "state")]
        public string State { get; set; }

        /// <summary>
        /// Gets address prefixes of the effective routes in CIDR notation.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "addressPrefix")]
        public System.Collections.Generic.IList<string> AddressPrefix { get; set; }

        /// <summary>
        /// Gets the IP address of the next hop of the effective route
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "nextHopIpAddress")]
        public System.Collections.Generic.IList<string> NextHopIpAddress { get; set; }

        /// <summary>
        /// Gets or sets the type of Azure hop the packet should be sent to.
        /// Possible values include: 'VirtualNetworkGateway', 'VnetLocal',
        /// 'Internet', 'VirtualAppliance', 'None'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "nextHopType")]
        public string NextHopType { get; set; }

    }
}
