// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Redis.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Response to put/get patch schedules for redis cache.
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class RedisPatchScheduleInner
    {
        /// <summary>
        /// Initializes a new instance of the RedisPatchScheduleInner class.
        /// </summary>
        public RedisPatchScheduleInner() { }

        /// <summary>
        /// Initializes a new instance of the RedisPatchScheduleInner class.
        /// </summary>
        /// <param name="scheduleEntries">List of patch schedules for redis
        /// cache.</param>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="location">Resource location</param>
        public RedisPatchScheduleInner(System.Collections.Generic.IList<ScheduleEntry> scheduleEntries, string id = default(string), string name = default(string), string type = default(string), string location = default(string))
        {
            Id = id;
            Name = name;
            Type = type;
            Location = location;
            ScheduleEntries = scheduleEntries;
        }

        /// <summary>
        /// Gets resource Id
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets resource name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets resource type
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

        /// <summary>
        /// Gets resource location
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "location")]
        public string Location { get; private set; }

        /// <summary>
        /// Gets or sets list of patch schedules for redis cache.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.scheduleEntries")]
        public System.Collections.Generic.IList<ScheduleEntry> ScheduleEntries { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ScheduleEntries == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "ScheduleEntries");
            }
            if (this.ScheduleEntries != null)
            {
                foreach (var element in this.ScheduleEntries)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
